VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} LoksimClient 
   Caption         =   "UserForm1"
   ClientHeight    =   4560
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6090
   OleObjectBlob   =   "LoksimClient.frx":0000
   StartUpPosition =   1  'Fenstermitte
End
Attribute VB_Name = "LoksimClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Dim Loksim As LoksimControl.LoksimAutoServer
Dim ActSpeed As Double
Dim LokMaxSpeed As Double
Dim ActSimTime As Double
Dim HauptSchalter As Boolean
Dim AnzeigeSifa As Boolean
Dim SchaltSoll As Double
Dim SchaltIst As Double
Dim HlDruck As Double
Dim ZylinderDruck As Double
Dim AfbStatus As Boolean
Dim AfbZiel As Double
Dim Ende As Boolean



Private Sub ButtonAFB_Click()
    If Not (Loksim Is Nothing) Then
        Loksim.SendKey (KEY_AFB)
    End If

End Sub

Private Sub ButtonAFBDown_Click()
    If Not (Loksim Is Nothing) Then
        Loksim.SendKey (KEY_STLEFT)
    End If

End Sub

Private Sub ButtonAFBUp_Click()
    If Not (Loksim Is Nothing) Then
        Loksim.SendKey (KEY_STRIGHT)
    End If

End Sub

Private Sub ButtonBremseDown_Click()
    If Not (Loksim Is Nothing) Then
        Loksim.SendKey (KEY_BREMSEN7)
    End If

End Sub

Private Sub ButtonBremseUp_Click()
    If Not (Loksim Is Nothing) Then
        Loksim.SendKey (KEY_BREMSEN1)
    End If

End Sub

Private Sub ButtonEnde_Click()
    Ende = True
 
End Sub

Private Sub ButtonHauptSchalter_Click()
    If Not (Loksim Is Nothing) Then
        Loksim.SendKey (KEY_HAUPTSCHALTER)
    End If
End Sub

Private Sub ButtonIndusi_Click()
    If Not (Loksim Is Nothing) Then
        Loksim.SendKey (KEY_INDUSI)
    End If
End Sub

Private Sub ButtonSchaltDown_Click()
    If Not (Loksim Is Nothing) Then
        Loksim.SendKey (KEY_STDOWN)
    End If
End Sub

Private Sub ButtonSchaltUp_Click()
    If Not (Loksim Is Nothing) Then
        Loksim.SendKey (KEY_STUP)
    End If

End Sub

Private Sub ButtonSifa_Click()
    If Not (Loksim Is Nothing) Then
        Loksim.SendKey (KEY_SIFA)
    End If
End Sub

Private Sub CommandButton1_Click()
    Ende = True
End Sub

Private Sub TimerFunction()
            Rem Timer1.Enabled = False
            If Not (Loksim Is Nothing) Then
                Loksim.StartWaitForCommands (500)
                If Loksim.LoksimIsRunning Then
                    If Loksim.SimulationIsRunning Then
                        StatusBar.Caption = "Alles ok"
                        Dim Params As String
                        LoksimUtilAddParam Params, cLOK_COMMON_ACTSPEED
                        LoksimUtilAddParam Params, cLOK_COMMON_MAXSPEED
                        LoksimUtilAddParam Params, cSIM_COMMON_SIMTIME
                        LoksimUtilAddParam Params, cLOK_ANZEIGE_HAUPTSCHALTER
                        LoksimUtilAddParam Params, cLOK_ANZEIGE_SIFA
                        LoksimUtilAddParam Params, cLOK_INSTRUMENT_SOLLSTUFE
                        LoksimUtilAddParam Params, cLOK_INSTRUMENT_ISTSTUFE
                        LoksimUtilAddParam Params, cLOK_INSTRUMENT_BREMSDRUCK
                        LoksimUtilAddParam Params, cLOK_INSTRUMENT_BREMSZYLINDERDRUCK
                        LoksimUtilAddParam Params, cLOK_ANZEIGE_AFB
                        LoksimUtilAddParam Params, cLOK_INSTRUMENT_AFB
                        Dim RetParams As String
                        RetParams = Loksim.GetSimData(Params)
                        ActSpeed = LoksimUtilGetParamFloat(RetParams, cLOK_COMMON_ACTSPEED)
                        HauptSchalter = LoksimUtilGetParamBool(RetParams, cLOK_ANZEIGE_HAUPTSCHALTER)
                        LokMaxSpeed = LoksimUtilGetParamFloat(RetParams, cLOK_COMMON_MAXSPEED)
                        ActSimTime = LoksimUtilGetParamFloat(RetParams, cSIM_COMMON_SIMTIME)
                        HauptSchalter = LoksimUtilGetParamBool(RetParams, cLOK_ANZEIGE_HAUPTSCHALTER)
                        AnzeigeSifa = LoksimUtilGetParamBool(RetParams, cLOK_ANZEIGE_SIFA)
                        SchaltSoll = LoksimUtilGetParamFloat(RetParams, cLOK_INSTRUMENT_SOLLSTUFE)
                        SchaltIst = LoksimUtilGetParamFloat(RetParams, cLOK_INSTRUMENT_ISTSTUFE)
                        HlDruck = LoksimUtilGetParamFloat(RetParams, cLOK_INSTRUMENT_BREMSDRUCK)
                        ZylinderDruck = LoksimUtilGetParamFloat(RetParams, cLOK_INSTRUMENT_BREMSZYLINDERDRUCK)
                        AfbStatus = LoksimUtilGetParamBool(RetParams, cLOK_ANZEIGE_AFB)
                        AfbZiel = LoksimUtilGetParamFloat(RetParams, cLOK_INSTRUMENT_AFB)
                    Else
                        StatusBar.Caption = "Simulation luft nicht oder pausiert"
                    End If
                Else
                    StatusBar.Caption = "Loksim luft nicht -> Loksim starten"
                End If
                Loksim.StopWaitForCommands
            Else
                StatusBar.Caption = "Ole-Server nicht gestartet -> Drcken sie Start"
            End If
            If HauptSchalter Then
                LabelHauptschalter.Caption = "An"
            Else
                LabelHauptschalter.Caption = "Aus"
            End If
            LabelActKMH.Caption = "V: " & ActSpeed
            LabelVMax.Caption = "Vmax: " & LokMaxSpeed
            LabelActSimTime.Caption = "ActSimTime: " & ActSimTime
            If AnzeigeSifa Then
                LabelSifa.Caption = "Lampe AN"
            Else
                LabelSifa.Caption = "Lampe AUS"
            End If
            LabelSchaltSoll.Caption = "Soll: " & SchaltSoll
            LabelSchaltIst.Caption = "Ist: " & SchaltIst
            LabelHLDruck.Caption = "HLDruck: " & HlDruck
            LabelZylDruck.Caption = "Zyl.Druck: " & ZylinderDruck
            If AfbStatus Then
                LabelAFBAn.Caption = "AFB AN"
            Else
                LabelAFBAn.Caption = "AFB AUS"
            End If
            LabelAFBV.Caption = "AFB-Ziel: " & AfbZiel
            Rem Timer1.Enabled = True
End Sub


Private Sub CommandButton2_Click()
    Set Loksim = CreateObject("LoksimControl.LoksimAutoServer")
Rem Eigentlich sollte die Timerfunction in einem Timer aufgerufen werden
Rem aber in VBA habe ich keinen gefunden.
Rem Wenn in VB einen Timer verwenden muss man darauf achten, dass am Anfang der Timerfunktion
Rem der timer disabled wird und am Ende wieder enabled. Das Programm hngt sonst, wenn der Loksim
Rem fr die Abarbeitung mehr Zeit braucht als das Timerintervall ist
    Ende = False
    Dim LastTime As Single
    Dim NewTime As Single
    LastTime = Timer
    While Not Ende
        TimerFunction
        NewTime = Timer
        DoEvents
        While NewTime - LastTime < 0.25 Or LastTime > NewTime
            Rem Sleep
            DoEvents
            NewTime = Timer
        Wend
        LastTime = Timer
    Wend
End Sub

Private Sub UserForm_Click()

End Sub

Private Sub UserForm_Terminate()
    Ende = True
End Sub
